% (c) 2009-2013 Lehrstuhl fuer Softwaretechnik und Programmiersprachen,
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html)

:- module(clpfd_off_interface,[try_post_constraint/1,
                            clpfd_eq/2, clpfd_neq/2,
                            clpfd_geq/2, clpfd_gt/2, clpfd_leq/2, clpfd_lt/2,
                            clpfd_domain/3]).

/* version of module with CLP(FD) turned off;
   recommended e.g. before SICStus 4.1 */

clpfd_eq(_,_).
clpfd_neq(_,_).
clpfd_geq(_,_).
clpfd_gt(_,_).
clpfd_leq(_,_).
clpfd_lt(_,_).

try_post_constraint(_).

clpfd_domain(Var,Low,Up) :- var(Var),!,Low=inf,Up=sup.
clpfd_domain(X,X,X).
