

:- assert_must_succeed(exhaustive_kernel_check(card_leq([int(2),int(4),int(1)],s(s(s(0)))))).
:- assert_must_succeed(exhaustive_kernel_check(card_leq([int(2)],s(0)))).
:- assert_must_succeed((kernel_objects:card_leq([int(1),int(2)],s(s(s(0)))))).
:- assert_must_succeed((kernel_objects:card_leq(global_set('Name'),s(s(s(0)))))).
:- assert_must_succeed((kernel_objects:card_leq([int(1),int(2)],s(s(0))))).
:- assert_must_fail((kernel_objects:card_leq([int(1),int(2)],s(0)))).
:- assert_must_fail((kernel_objects:card_leq(global_set('Name'),s(s(0))))).
:- block card_leq(-,?).
card_leq(Set,Card) :-
 ((nonvar(Set),is_custom_explicit_set(Set,card_leq))
   -> explicit_set_cardinality(Set,CCard), leq_int_peano(CCard,Card)
   ;  card_leq2(Set,Card) ).
:- block card_leq2(-,?).
card_leq2([],_C).
card_leq2([_|T],s(C)) :- card_leq2(T,C). %when(nonvar(T),card_leq2(T,C)).
card_leq2(avl_set(A),C) :- card_leq(avl_set(A),C).
card_leq2(closure(P,T,B),C) :- card_leq(closure(P,T,B),C).
card_leq2(global_set(A),C) :- card_leq(global_set(A),C).
card_leq2(freetype(A),C) :- card_leq(freetype(A),C).

:- block leq_int_peano(-,?).
leq_int_peano(0,_).
leq_int_peano(inf,_) :- !,fail.
leq_int_peano(X,s(C)) :- X>0, X1 is X-1, leq_int_peano(X1,C).

/*
basic_type2(set(Type),Set) :- !,basic_type_set(Type,Set,inf).
basic_type2(_,_).

:- use_module(inf_arith).
basic_type_set(Type,Set,Bound) :-
  (kernel_objects:max_cardinality(Type,C)
    -> inf_arith:infmin(C,Bound,Card)
     ; Card=inf),
   %print(basic_type_set(Set,Card,Type)),nl,nl,
   basic_type_set(Set,[],Type,Card).

:- block basic_type_set(-,?,?,?).
%basic_type_set(S,Sofar,T) :- print_message(basic_type_set(S,Sofar,T)),fail.
basic_type_set(CustomSet,_,_Type,_) :- is_custom_explicit_set(CustomSet,basic_type_set),!.
basic_type_set([],_,_,_).
basic_type_set([H|T],ElementsSoFar,Type,Card) :-
   inf_arith:infdec_if_positive(Card,C1),
   basic_type(H,Type),
   not_element_of(H,ElementsSoFar), %consistent([H|ElementsSoFar]),
   (C1=0 -> empty_set(T) ; basic_type_set(T,[H|ElementsSoFar],Type,C1)).

:- use_module(kernel_sym_break_order).
basic_symbreak(set(_),Set) :- !,sym_break_set(Set).
basic_symbreak(seq(_),Set) :- !,sym_break_set(Set).
basic_symbreak(_,_). */

/*
basic_type2(global(T),fd(X,T)) :- global_type(fd(X,T),T). % will set up CLP(FD) domain for X
basic_type2(set(Type),Set) :- basic_type_set(Set,[],Type).
basic_type2(seq(X),Seq) :- basic_type(Seq,set(couple(integer,X))).
basic_type2(boolean,_).
%% basic_type2(boolean,pred_true). basic_type2(boolean,pred_false).
basic_type2(couple(XT,YT),(X,Y)) :- basic_type(X,XT), basic_type(Y,YT).
basic_type2(string,string(_)).
basic_type2(constant(List),term(T)).
basic_type2(integer,int(_X)). %  :- clpfd_interface:clpfd_inrange(_X,-999999,999999). %%%%
basic_type2(string,string(_)).
basic_type2(record(FieldTypes),rec(Fields)) :-
  basic_field_types(Fields,FieldTypes,rec(Fields),record(FieldTypes)).
basic_type2(freetype(Id),freeval(Id,Case,Val)) :- basic_type_freetype(Id,Case,Val).
basic_type2(any,_).

:- block basic_type_set(-,?,?).
%basic_type_set(S,Sofar,T) :- print_message(basic_type_set(S,Sofar,T)),fail.
basic_type_set(CustomSet,[],_Type) :- is_custom_explicit_set(CustomSet,basic_type_set),!.
basic_type_set([],_,_).
basic_type_set([H|T],ElementsSoFar,Type) :-
   basic_type(H,Type),
   not_element_of(H,ElementsSoFar), %consistent([H|ElementsSoFar]),
   basic_type_set(T,[H|ElementsSoFar],Type).



:- block basic_type_freetype(?,-,?).
basic_type_freetype(Id,Case,Val) :-
   registered_freetype(Id,Cases),
   member(case(Case,CT),Cases),!,
   basic_type(Val,CT).

:- block basic_field_types(-,-,?,?).
basic_field_types([],[],_,_).
basic_field_types([field(Name1,Val)|T],[field(Name2,VT)|TT],Orig1,Orig2) :-
     basic_field_types2(Name1,Val,T,Name2,VT,TT,Orig1,Orig2).

:- block basic_field_types2(?,?,?, -,?,?,?,?).
basic_field_types2(Name1,Val,T,Name2,VT,TT,Orig1,Orig2) :-
  (Name1=Name2
   -> basic_type(Val,VT),
      basic_field_types(T,TT,Orig1,Orig2)
    ;  add_error(kernel_objects,'Record field names do not match: ',(Name1,Name2,Orig1,Orig2)),
       fail
  ).


*/
