:- module(ltsmin_c_interface, [put_chunk/3,
                               put_chunk_written/3,
                               ltsmin_initialize/2,
                               h_zocket2/2,
                               /*ltsmin_loop,*/
                               ltsmin_teardown/2,
                               put_number/2,
                               create_message/1,
                               append_message/2,
                               read_hex_str/2,
                               free_str/1,
                               atom_charptr/2,
                               loadfr/0,
                               reset_c_counters/0]).


foreign(put_chunk, put_chunk(+address(zmsg_t),+address(char),+integer)).
foreign(put_chunk_written, put_chunk_written(+address(zmsg_t),+address(char),+integer)).
foreign(ltsmin_initialize, ltsmin_initialize(+string, [-address(void)])).
%foreign(ltsmin_loop, ltsmin_loop(+address(void))).
foreign(h_zocket2, h_zocket2(+address(void), [-integer])).
foreign(ltsmin_teardown, ltsmin_teardown(+address(void), +string)).
foreign(put_number, put_number(+address(zmsg_t),+integer)).
foreign(create_message, create_message([-address(zmsg_t)])).
foreign(append_message, append_message(+address(zmsg_t),+address(zmsg_t))).
foreign(read_hex_str, read_hex_str(+codes,[-address(char)])).
foreign(free_str, free_str(+address(char))).
foreign(atom_charptr, atom_charptr(+codes, [-address(char)])).
foreign(reset_c_counters, reset_c_counters).


foreign_resource(ltsmin,
                 [put_chunk,put_chunk_written,ltsmin_initialize,h_zocket2,/*ltsmin_loop,*/ltsmin_teardown,put_number,create_message,append_message,read_hex_str, free_str,atom_charptr, reset_c_counters]).

:- dynamic loaded/0.

loadfr :-
    (loaded -> true
     ; (assert(loaded),
        %assert_dir,
        load_foreign_resource(library(ltsmin)))).
