
tcltk_ltsmin_init :-
    Endpoint = '/tmp/ltsmin.probz',
    ltsmin:ltsmin_init(Endpoint, Zocket),
    preferences:get_preference(path_to_ltsmin, LTSminPath),
    atom_concat(LTSminPath,'/prob2lts-sym',LTSminCmd),
    (%system_call_keep_open(LTSminCmd, [Endpoint], PID, _StdIn, _StdOut, _StdErr, [])
     system_call_keep_open_no_pipes(LTSminCmd, [Endpoint],PID, []) % with this version we at least see the LTSmin output
     -> true
     ;  ajoin(['Could not start prob2lts-sym in: ',LTSminPath,', ensure that path_to_ltsmin preference is correct!'],Msg),
        add_error(ltsmin,Msg),fail),
    % TODO: further command line options to ltsmin?
    % TODO: handle streams
    print(starting_ltsmin_loop(LTSminCmd)),nl, %system:sleep(10),
    ltsmin:ltsmin_loop(Zocket),
    process_release(PID),
    ltsmin:ltsmin_teardown(Zocket, Endpoint).
